---
title: Worklet.addModule()
slug: Web/API/Worklet/addModule
tags:
  - API
  - Background
  - Experimental
  - Houdini
  - Method
  - Multiprocessor
  - Processes
  - Reference
  - Tasks
  - Worklets
  - addModule
---
<div>{{APIRef("Worklets")}}{{SeeCompatTable}}</div>

<p><span class="seoSummary">The <code><strong>addModule()</strong></code> method of the {{domxref("Worklet")}} interface loads the module in the given JavaScript file and adds it to the current <code>Worklet</code>.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>addPromise</em> = <em>worklet</em>.addModule(<em>moduleURL</em>);
<em>addPromise =</em> <em>worklet</em>.addModule(<em>moduleURL</em>, <em>options</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>moduleURL</code></dt>
 <dd>A {{jsxref("String")}} containing the URL of a JavaScript file with the module to add.</dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An object with any of the following options:
 <ul>
  <li><code>credentials</code>: A {{domxref("RequestCredentials")}} value that indicates whether to send credentials (e.g. cookies and HTTP authentification) when loading the module. Can be one of <code>"omit"</code>, <code>"same-origin"</code>, or <code>"include"</code>. Defaults to <code>"same-origin"</code>. See also {{domxref("Request.credentials")}}.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves once the module from the given URL has been added. The promise doesn't return any value.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>If <code>addModule()</code> fails, it rejects the promise, delivering one of the following errors to the rejection handler.</p>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>The specified script is invalid or could not be loaded.</dd>
 <dt><code>SyntaxError</code></dt>
 <dd>The specified <code>moduleURL</code> is invalid.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="AudioWorklet_example">AudioWorklet example</h3>

<pre class="brush: js highlight:[3,4,5] notranslate">const audioCtx = new AudioContext();
const audioWorklet = audioCtx.audioWorklet;
await audioWorklet.addModule('modules/bypassFilter.js', {
  credentials: 'omit',
});
</pre>

<h3 id="PaintWorklet_example">PaintWorklet example</h3>

<pre class="brush: js notranslate">CSS.paintWorklet.addModule('https://mdn.github.io/houdini-examples/cssPaint/intro/worklets/hilite.js');</pre>

<p>Once a {{domxref('paintWorklet')}} is included, the CSS {{cssxref('paint()')}} function can be used to include the image created by the worklet:</p>

<pre class="brush: css notranslate">@supports (background-image: paint(id)) {
  h1 {
      background-image: paint(hollowHighlights, filled, 3px);
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-worklet-addmodule', 'addModule()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.Worklet.addModule")}}</p>
